Status: New Start date: 03 Aug 2023

Priority: Low Due date:  

Assignee:  % Done: 0%

Category: Parser/Interpreter Estimated time: 0.00 hour

Target version: CoCoA-5.4.4 Spent time: 0.60 hour

Description

I mistyped and obtained an error message which could be better:

/**/ [1.2.3.4];

--> ERROR: I was expecting an identifier but I've found the number "3.4" 

--> [1.2.3.4];

-->      ^^^

History

#1 - 03 Aug 2023 16:05 - John Abbott

Maybe try some other similar wrong inputs?  1.2.  or  1.2.3  or even 1.2.3.4.5

#2 - 05 Aug 2023 11:10 - John Abbott

Here is the current state:

/**/ 1.2.

[[waiting for semicolon]] /**/ ;

--> ERROR: I was expecting an identifier but I've found the operator/symbol ";" 

--> ;

--> ^

/**/ 1.2.3

--> ERROR: I was expecting an identifier but I've found the number "3" 

--> 1.2.3

-->     ^

/**/ 1.2.3.

--> ERROR: I was expecting an identifier but I've found the number "3" 

--> 1.2.3.

-->     ^

/**/ 1.2.3.4

--> ERROR: I was expecting an identifier but I've found the number "3.4" 

--> 1.2.3.4

-->     ^^^

/**/ 1.2.3.4.

--> ERROR: I was expecting an identifier but I've found the number "3.4" 

--> 1.2.3.4.

-->     ^^^

/**/ 1.2.3.4.5

--> ERROR: I was expecting an identifier but I've found the number "3.4" 

--> 1.2.3.4.5

-->     ^^^

 

Also

/**/ 1.

[[waiting for semicolon]] /**/ ;

--> ERROR: I was expecting an identifier but I've found the operator/symbol ";" 

--> ;

--> ^
#3 - 18 Mar 2024 20:59 - John Abbott

- Target version changed from CoCoA-5.4.2 to CoCoA-5.4.4

#4 - 19 Mar 2024 20:05 - John Abbott

The relevant source code is probably in Parser.C near line 1924 inside the function parseSelectors right after case TT_DOT:

Is it really worth trying to handle this case?  I do sometimes mistakenly type a dot instead of a comma, and it is not always so obvious that I have

mistyped... A friendlier error message would be nice, but may be complicated to achieve.  Maybe we should just document somewhere(??) that an

unhelpful error message may arise when a comma is mistyped as a dot...?  How about

a := 123;

L := [a. 2]; // where I *thought* I had typed a comma

Again we get ERROR: I was expecting an identifier...
